SystemOrganization addCategory: #DspContactBook!
SystemOrganization addCategory: 'DspContactBook-Components'!
SystemOrganization addCategory: 'DspContactBook-Tests'!

WAComponent subclass: #DspWAContact
	instanceVariableNames: 'contact'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspContactBook-Components'!

!DspWAContact commentStamp: 'didierSaintPastou 5/28/2016 15:04' prior: 0!
A compoment for a contact!

!DspWAContact class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/28/2016 15:05'!
editContact: aContact
	^ self new
		setContact: aContact;
		yourself! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:05'!
contact
	^ contact! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:06'!
initialize
	super initialize.
	contact := DspContact new.! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:16'!
renderButtonsForContact: aContact on: html
	html tbsButtonGroup: [
		self
			renderEditButtonForContact: aContact on: html;
			renderRemoveButtonForContact: aContact on: html ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:13'!
renderButtonsOn: html
	html tbsFormGroup: [
		html tbsButtonGroup: [
			self
				renderSubmitButtonOn: html;
				renderCancelButtonOn: html ] ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:14'!
renderCancelButtonOn: html
	html tbsButton
		beDanger;
		cancelCallback: [ self answer: nil ];
		with: 'Cancel'! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:16'!
renderContact: aContact on: html
	html tableRow: [
		html
			tableData: aContact fullname;
			tableData: aContact email;
			tableData: [ self renderPhotoOf: aContact on: html ];
			tableData: [ self renderButtonsForContact: aContact on: html ] ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:12'!
renderContentOn: html
	html tbsContainer: [
		html heading with: 'Contact Editing'.
		html tbsForm with: [
			self renderFieldsOn: html.
			self renderButtonsOn: html ] ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:16'!
renderEditButtonForContact: aContact on: html
	html tbsButton
		beSuccess;
			callback: [ self call: (DspWAContact editContact: aContact) ];
			with: 'Edit'! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:10'!
renderEmailFieldOn: html
	html tbsFormGroup: [
		html label: 'Email'.
		html emailInput
			tbsFormControl;
			placeholder: 'your@email.eu';
			callback: [ :email | self contact email: email address ];
			value: (self contact email ifNil: '') ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:07'!
renderFieldsOn: html
	self renderFullnameFieldOn: html.
	self renderEmailFieldOn: html! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:09'!
renderFullnameFieldOn: html
	html tbsFormGroup: [
		html label: 'Fullname'.
		html textInput
			tbsFormControl;
			placeholder: 'fullname';
			callback: [ :value | self contact fullname: value ];
			value: (self contact fullname ifNil: '') ]! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:13'!
renderSubmitButtonOn: html
	html tbsSubmitButton
		beSuccess;
		bePrimary;
		callback: [ self answer: self contact ];
		with: 'Save'! !

!DspWAContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 15:06'!
setContact: aContact
	contact := aContact! !

WAComponent subclass: #DspWAContactBook
	instanceVariableNames: 'contactBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspContactBook-Components'!

!DspWAContactBook commentStamp: 'didierSaintPastou 5/27/2016 20:17' prior: 0!
The view of model DspContactBook!

!DspWAContactBook class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/28/2016 14:35'!
initialize
	" register self to the /contacts URL "
	(WAAdmin register: self asApplicationAt: 'contacts')
		addLibrary: JQDeploymentLibrary;
		addLibrary: TBSDeploymentLibrary! !

DspWAContactBook initialize!

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 15:20'!
addContact
	(self call: DspWAContact new)
		ifNotNil: [ :contact | contactBook addContact: contact ]! !

!DspWAContactBook methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 20:27'!
contactBook
	^ contactBook ifNil: [ contactBook := DspContactBook createDefault ]! !

!DspWAContactBook methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 20:51'!
contacts
	^ self contactBook contacts! !

!DspWAContactBook methodsFor: 'iterating' stamp: 'didierSaintPastou 5/27/2016 20:28'!
contactsDo: aBlock
	self contacts do: aBlock! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 14:54'!
renderContact: aContact on: html
	html tableRow: [
		html
			tableData: aContact fullname;
			tableData: aContact email;
			tableData: [ self renderPhotoOf: aContact on: html ];
			tableData: [ self renderRemoveButtonForContact: aContact on: html ] ]! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 14:49'!
renderContactsOn: html
	html tbsTable: [
		html tableHead: [
			html
				tableHeading: 'Name';
				tableHeading: 'Email';
				tableHeading: 'Photo' ].
		self contactsDo: [ :contact | self renderContact: contact on: html ] ]! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 15:18'!
renderContentOn:  html
	"Main entry point of the view. Render both a title and the list of contacts."
	html tbsContainer: [
		html heading
			level: 1;
			with: 'My Contact Book'.
		 html tbsForm: [ 
			self renderContactsOn: html.
			self renderGlobalButtonsOn: html ]  ]! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 15:19'!
renderGlobalButtonsOn: html
	html tbsButtonGroup: [
		html tbsButton
			beSuccess;
			callback: [ self addContact ];
			with: 'New contact' ]
! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 14:52'!
renderPhotoOf: aContact on: html
	html image url: aContact gravatarUrl! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/28/2016 14:55'!
renderRemoveButtonForContact: aContact on: html
	html tbsButton
		beDanger;
		callback: [ self contactBook removeContact: aContact ];
		with: 'Remove'! !

!DspWAContactBook methodsFor: 'rendering' stamp: 'didierSaintPastou 5/27/2016 20:24'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Contact Book'! !

TestCase subclass: #DspTestContact
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspContactBook-Tests'!

!DspTestContact commentStamp: 'didierSaintPastou 5/27/2016 17:33' prior: 0!
Tests!

!DspTestContact methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 20:06'!
testAddRemoveContact
	| contact cB|
	contact := DspContact newNamed: 'n1' email: 'e1'.
	cB := DspContactBook new.
	cB addContact: contact.
	cB addContact: contact.
	cB addContact: contact.
	self assert: cB contacts size equals: 1.
	cB removeContact: contact.
	self assert: cB contacts size equals: 0.
	contact := DspContact newNamed: 'n2' email: 'e2'.
	cB removeContact: contact.
	self assert: cB contacts size equals: 0.
	cB addContact: contact.
	self assert: cB contacts size equals: 1.
	cB removeContact: contact.
	self assert: cB contacts size equals: 0.
	
	! !

!DspTestContact methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 20:12'!
testCreation
	| contact cB|
	contact := DspContact newNamed: '  Marcus    Denker  ' email: '   Marcus.Denker@inria.fr   '.
	self assert: contact fullname equals: 'Marcus Denker'.
	self assert: contact email equals: 'marcus.denker@inria.fr'.
	self assert: contact printString equals: 'Marcus Denker <marcus.denker@inria.fr>' .
	cB := DspContactBook createDefault .
	self assert: cB contacts size equals: 4 .! !

Object subclass: #DspContact
	instanceVariableNames: 'fullname email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspContactBook'!

!DspContact commentStamp: 'didierSaintPastou 5/27/2016 18:15' prior: 0!
I am a contact with a fullname and an email .
I'm usually part of a contact book

(DspContact newNamed: '    Marcus       Denker    ' email: '                 Marcus.DENKER@inria.fr          ' ) printString = 'Marcus Denker <marcus.denker@inria.fr>'!

!DspContact class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 17:45'!
newNamed: aFullname email: anEmail
	^ self new 
		fullname: aFullname ;
		email: anEmail ;
		yourself! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 17:40'!
email
	^ email! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 18:05'!
email: anObject
	email := anObject withBlanksCondensed asLowercase! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 17:29'!
fullname
	^ fullname! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 18:06'!
fullname: anObject
	fullname := anObject withBlanksCondensed! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/28/2016 14:48'!
gravatarUrl
	^ 'http://www.gravatar.com/avatar/', (MD5 hashMessage: email) hex, '.jpg'! !

!DspContact methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 18:07'!
printOn: aStream
	aStream
		nextPutAll: self fullname;
		nextPutAll: ' <';
		nextPutAll: self email;
		nextPutAll: '>'! !

Object subclass: #DspContactBook
	instanceVariableNames: 'contacts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspContactBook'!

!DspContactBook commentStamp: 'didierSaintPastou 5/27/2016 20:07' prior: 0!
I manage contacts
A contact is unique in my book!

!DspContactBook class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 20:09'!
createDefault
	^ self new
		addContact: (DspContact newNamed: 'Damien Cassou' email: 'damien@cassou.me');
		addContact: (DspContact newNamed: 'Marcus Denker'email: 'marcus.denker@inria.fr');
		addContact: (DspContact newNamed: 'Tudor Girba' email: 'tudor@tudorgirba.com');
		addContact: (DspContact newNamed: 'Clara Allende' email: 'clari.allende@gmail.com');
		yourself! !

!DspContactBook methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 20:05'!
addContact: aContact
	self removeContact: aContact .
	self contacts add: aContact! !

!DspContactBook methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 19:56'!
contacts
	^ contacts ifNil: [  contacts := OrderedCollection new ]! !

!DspContactBook methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 19:58'!
removeContact: aContact
	self contacts remove: aContact ifAbsent: ["don't mind" ]! !

DspWAContactBook initialize!
